

function isValid(bcd, n){
  for (let i=0; i < n; i++){
    if ((bcd & 0xF) > 9)
      return false;
    bcd = bcd >> 4;
  }
  return true;
}

function int2BCD(b, n){
  ;
}

function BCD2Int(bcd, n){
  let v = 0
  for (let i=0; i < n; i++){
    let d = bcd >> (i*4);
    v += (d & 0x0F) * Math.pow(10,i);
  }
  return v;
}

function add(a, b, n){
  let c = 0;
  let v = 0;
  for (i=0; i < (n*4); i += 4){
    let nibA = (a >> i) & 0x0F;
    let nibB = (b >> i) & 0x0F;
    let r = nibA + nibB + c;
    c = (r > 9) ? 1 : 0;
    r = (c == 1) ? (r + 6) & 0x0F : r;
    v = v | (r << i);
  }
  return v;
}


var BCD = Object.freeze({
  isValid: isValid,
  int2BCD: int2BCD,
  BCD2Int: BCD2Int,
  add: add
});

module.exports = BCD;
